import {
  Metadata,
} from '@zeedhi/core';
import {
  Modal,
  ModalService,
  Form,
  Select,
  SelectMultiple,
} from '@zeedhi/common';

export class AutomaticProfileAccessRegistrationController {
  private modalAutomaticRegistration!: Modal;

  public async createAutomaticProfileAccessRegistration() {
    this.modalAutomaticRegistration = await ModalService.createFromJson(
      '/modals/automaticProfileAccessRegistrationModal', true,
    );
  }

  public openAutomaticProfileAccessRegistration() {
    this.modalAutomaticRegistration.show();
  }

  public closeAutomaticProfileAccessRegistration() {
    this.modalAutomaticRegistration.hide();
  }
  
  public isUseStandardParameterization({ component }) {
    const form = Metadata.getInstance<Form>('automaticRegistrationForm');
    const panel = form.getChildInstance<Select>('panelCode');
    const indicator = form.getChildInstance<SelectMultiple>('isVisibleIndicators');
    const profile = form.getChildInstance<SelectMultiple>('accessProfileAutomaticRegistration');
    const exceptionProfile = form.getChildInstance<SelectMultiple>('exceptionByOperator');
    if (component.value === 'S') {
      panel.disabled = true;
      indicator.disabled = true;
      profile.disabled = true;
      exceptionProfile.disabled = true;
    }
    panel.disabled = false;
    indicator.disabled = false;
    profile.disabled = false;
    exceptionProfile.disabled = false;
  }
}
