import { Http } from '@zeedhi/core';
import { Modal, ModalService } from '@zeedhi/common';

export class DaysOfStockGOModalController {
  private daysOfStockGOModal!: Modal;
  
  private daysOfStockGOReportModal!: Modal;
  
  public dateValue: string = '';

  public async createDaysOfStockGOModal() {
    this.daysOfStockGOModal = await ModalService.createFromJson('/modals/daysOfStockGOModal', true);
  }

  public destroyDaysOfStockGOModal() {
    this.daysOfStockGOModal?.destroy();
  }

  public openDaysOfStockGOModal() {
    this.daysOfStockGOModal.show();
  }

  public closeDaysOfStockGOModal() {
    this.daysOfStockGOModal.hide();
  }

  public async createDaysOfStockGOReportModal() {
    this.daysOfStockGOReportModal = await ModalService.createFromJson('/modals/daysOfStockGOReportModal', true);
  }

  public destroyDaysOfStockGOReportModal() {
    this.daysOfStockGOReportModal?.destroy();
  }

  public openDaysOfStockGOReportModal() {
    this.daysOfStockGOReportModal.show();
  }

  public closeDaysOfStockGOReportModal() {
    this.daysOfStockGOReportModal.hide();
  }
  
  public openReportDaysOfStock(component) {
    const data = this.dateInterval;
    const format = component.component.name === 'downloadPdfDaysOfStock' ? 'PDF' : 'XLSX';
    const sendObject = {
      P_DATAINI: data[0] ? data[0] : '',
      P_DATAFIN: data[1] ? data[1] : '',
      __format: format,
      __report_name: 'DIASESTOQUEGO',
    };
    Http.post('/openReport', {
      requestType: 'Row',
      row: sendObject,
    }).then((response) => {
      const file = response.data;
      window.open(file);
      /* REMOVER DEPOIS DA DEFINIÇÃO DE DOWNLOAD DE RELATORIO NO NEXT
      
      const a = document.createElement('a');
      document.body.appendChild(a);
      a.style.display = 'none';
      a.href = `data:application/octet-stream;base64,${file}`;
      a.download = `DIASESTOQUEGO.${extension}`;
      a.click(); */
    });
  }
  
  get dateInterval(): string {
    return this.dateValue;
  }
}
